#pragma once
#include <vector>
#include "ffgl/ParamBase.h"

namespace ffgl
{

class ParamBuffer : public ParamBase
{
protected:
	ParameterUsage usage;

public:
	static constexpr size_t DEFAULT_BUFFER_SIZE = 1024;

	ParamBuffer( const std::string& name, size_t bufferSize = DEFAULT_BUFFER_SIZE, ParameterUsage usage = ParameterUsage::FF_USAGE_STANDARD );

	~ParamBuffer();

	void Reset() override;
	const std::string& GetDisplay() const override;
	FFMixed GetMixedDefault() const override;
	FFMixed GetMixedValue() const override;
	FFResult SetMixedValue( FFMixed mixed ) override;

	ParameterUsage GetUsage() const;

	std::vector< float > data;
};

}//End namespace ffgl
